=== modified file 'unity-shared/CompizUtils.cpp'
--- unity-shared/CompizUtils.cpp	2016-07-26 11:33:50 +0000
+++ unity-shared/CompizUtils.cpp	2016-08-01 13:01:10 +0000
@@ -190,7 +190,11 @@
   if (win->wmType() & (CompWindowTypeDockMask | CompWindowTypeDesktopMask))
     return elements;
 
-  if (win->alpha())
+  auto const& region = win->region();
+  bool rectangular = (region.numRects() == 1);
+  bool alpha = win->alpha();
+
+  if (alpha)
   {
     if (wf == WindowFilter::CLIENTSIDE_DECORATED)
     {
@@ -201,7 +205,7 @@
 
       return elements;
     }
-    else if (win->region().numRects() != 1) // Non-rectangular windows with alpha channel
+    else if (!rectangular) // Non-rectangular windows with alpha channel
     {
       return elements;
     }
@@ -209,6 +213,9 @@
 
   elements |= DecorationElement::SHADOW;
 
+  if (!rectangular)
+    elements |= DecorationElement::SHAPED;
+
   if (!win->overrideRedirect() &&
       (win->type() & DECORABLE_WINDOW_TYPES) &&
       (win->frame() || win->hasUnmapReference() || wf == WindowFilter::UNMAPPED))
@@ -216,14 +223,11 @@
     if (win->actions() & CompWindowActionResizeMask)
       elements |= DecorationElement::EDGE;
 
-    auto const& region = win->region();
-    bool rectangular = (region.numRects() == 1);
-
     if (rectangular && (win->mwmDecor() & (MwmDecorAll | MwmDecorTitle)))
       elements |= DecorationElement::BORDER;
   }
 
-  if (win->alpha() && !(elements & DecorationElement::BORDER) && !(win->mwmDecor() & MwmDecorBorder))
+  if (alpha && !(elements & DecorationElement::BORDER) && !(win->mwmDecor() & MwmDecorBorder))
     elements &= ~DecorationElement::SHADOW;
 
   return elements;

=== modified file 'unity-shared/CompizUtils.h'
--- unity-shared/CompizUtils.h	2015-11-02 14:58:01 +0000
+++ unity-shared/CompizUtils.h	2016-08-01 13:01:10 +0000
@@ -133,7 +133,8 @@
   NONE = 0,
   EDGE = (1 << 0),
   SHADOW = (1 << 1),
-  BORDER = (1 << 2),
+  SHAPED = (1 << 2),
+  BORDER = (1 << 3),
   FULL = EDGE|SHADOW|BORDER
 };
 }

